package net.t2code.t2codelib.VELOCITY.api.pluginMessaging;


import com.google.common.io.ByteArrayDataInput;
import com.google.common.io.ByteStreams;
import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.connection.PluginMessageEvent;
import com.velocitypowered.api.event.proxy.ProxyInitializeEvent;
import com.velocitypowered.api.proxy.Player;
import com.velocitypowered.api.proxy.ProxyServer;
import net.t2code.t2codelib.VELOCITY.api.commands.T2CVcmd;
import net.t2code.t2codelib.VELOCITY.system.T2CodeVMain;
import org.slf4j.Logger;

public class T2CplmsgBcmd {

    public static ProxyServer server = T2CodeVMain.server;
    public static Logger logger = T2CodeVMain.logger;


    @Subscribe
    public void onProxyInitialization(ProxyInitializeEvent event) {
       server.getChannelRegistrar().register(T2CodeVMain.bcmd);
        //  server.getChannelRegistrar().register(IDENTIFIER2);
    }

    @Subscribe
    public void onPluginMessageFromPlayer(PluginMessageEvent event) {
        if (event.getIdentifier() != T2CodeVMain.bcmd) {
            return;
        }
        ByteArrayDataInput stream = ByteStreams.newDataInput(event.getData());
        String channel = stream.readUTF();
        String input = stream.readUTF();
        String serverID;
        try {
            serverID = stream.readUTF();
        } catch (Exception i) {
            serverID = "not Found";
        }

        if (channel.equals("T2Code-Console")) {
            logger.info("{} [{}] T2C BCMD Command Console: {}", T2CodeVMain.prefix, serverID, input);
          T2CVcmd.Console(input);
        } else {
            Player player = server.getPlayer(channel).orElse(null);
            if (player != null) {
                logger.info("{} [{}] T2C BCMD Command {}: {}", T2CodeVMain.prefix, serverID, player, input);
                T2CVcmd.Player(player, input);
            }
        }
        event.setResult(PluginMessageEvent.ForwardResult.handled());
    }

}
