package net.t2code.t2codelib.VELOCITY.api.update;

import com.velocitypowered.api.plugin.PluginContainer;
import com.velocitypowered.api.proxy.ProxyServer;
import net.t2code.t2codelib.T2CVupdateObject;
import net.t2code.t2codelib.T2CupdateWebData;
import net.t2code.t2codelib.VELOCITY.system.T2CodeVMain;
import org.json.JSONArray;
import org.json.JSONObject;
import org.slf4j.Logger;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Optional;
import java.util.function.Consumer;

public class T2CVupdateCheckerGit {
    private Optional<PluginContainer> plugin;
    private int resourceId;
    public static ProxyServer server = T2CodeVMain.server;
    public static Logger logger = T2CodeVMain.logger;

    public T2CVupdateCheckerGit(Optional<PluginContainer> plugin, int resourceId) {
        this.plugin = plugin;
        this.resourceId = resourceId;
    }

    public void getVersion(Consumer<T2CupdateWebData> consumer, String pluginVersion, Integer spigotID, String gitKey) {
     //   if (T2CVlibConfig.getUpdateCheckFullDisable()) return;
        String RepoURL = "https://git.t2code.net/api/v1/repos/" + gitKey + "/releases?limit=1";
    //    if (!T2CVlibConfig.getSeePreReleaseUpdates()) {
            RepoURL = RepoURL + "&pre-release=false";
    //    }
        String finalRepoURL = RepoURL;
        try {
            URL url = new URL(finalRepoURL);
            URLConnection yc = url.openConnection();
            BufferedReader in = new BufferedReader(
                    new InputStreamReader(
                            yc.getInputStream()));
            String inputLine;
            String data = "";
            while ((inputLine = in.readLine()) != null)
                data = inputLine;
            in.close();
            data = data.substring(1, data.length() - 1);
            if (data.isEmpty()) {
                consumer.accept(null);
                return;
            }
            JSONObject obj = new JSONObject(data);
            String updateTitle = obj.getString("name");
            String version = obj.getString("tag_name");
            String updateDescription = obj.getString("body").replace("\n", "<br>").replace("\r", "").replace("'", "''");
            String updateUrl = obj.getString("html_url");
            boolean preRelease = obj.getBoolean("prerelease");

            String date = obj.getString("published_at");
            SimpleDateFormat inputFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
            SimpleDateFormat outputFormat = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss a");
            Date parsedDate = inputFormat.parse(date);
            String publishedAt = outputFormat.format(parsedDate);

            JSONArray downloadArray = obj.getJSONArray("assets");
            String gitURL = updateUrl;
            String downloadURL;
            if (downloadArray.isEmpty()) {
                downloadURL = "https://www.spigotmc.org/resources/" + spigotID;
            } else {
                downloadURL = downloadArray.getJSONObject(0).getString("browser_download_url");
            }

            if (!preRelease) {
                downloadURL = "https://www.spigotmc.org/resources/" + spigotID;
                updateUrl = "https://www.spigotmc.org/resources/" + spigotID;
            }

            T2CupdateWebData webData = new T2CupdateWebData(updateTitle, version, updateDescription, updateUrl, publishedAt, downloadURL, gitURL, preRelease);
            consumer.accept(webData);
        } catch (Exception var10) {
            Boolean load = false;
            if (T2CVupdateAPI.bungeePluginVersins.containsKey(plugin.get().getDescription().getName())) {
                load = T2CVupdateAPI.bungeePluginVersins.get(plugin.get().getDescription().getName()).load;
            }
            T2CVupdateObject update = new T2CVupdateObject(
                    plugin.get().getDescription().getName(),
                    Optional.ofNullable(pluginVersion),
                    null,
                    load,
                    false,
                    true
            );
            T2CVupdateAPI.bungeePluginVersins.put(plugin.get().getDescription().getName(), update);
            logger.info("§4 Cannot look for updates: {}", var10.getMessage());
        }

    }
}
