package net.t2code.t2codelib.VELOCITY.system;

import com.google.inject.Inject;
import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.proxy.ProxyInitializeEvent;
import com.velocitypowered.api.event.proxy.ProxyShutdownEvent;
import com.velocitypowered.api.plugin.PluginContainer;
import com.velocitypowered.api.proxy.ProxyServer;
import com.velocitypowered.api.proxy.messages.MinecraftChannelIdentifier;
import com.velocitypowered.api.scheduler.Scheduler;
import net.t2code.t2codelib.Util;
import net.t2code.t2codelib.VELOCITY.api.proxyPlayers.T2CVPlayers;
import net.t2code.t2codelib.VELOCITY.api.messages.T2CVsend;
import net.t2code.t2codelib.VELOCITY.api.update.T2CVupdateAPI;
import org.slf4j.Logger;

import java.io.IOException;
import java.util.Optional;
import java.util.concurrent.TimeUnit;

public class T2CodeVMain  {


    public static Optional<PluginContainer> pluginContainer;



   public static final String prefix = "[T2CodeLib]";
    public static ProxyServer server;
    public static Logger logger;
    public static final MinecraftChannelIdentifier bcmd = MinecraftChannelIdentifier.from("t2c:bcmd");
    public static final MinecraftChannelIdentifier bonlp = MinecraftChannelIdentifier.from("t2c:bonlp");
    public static final MinecraftChannelIdentifier cguiopl = MinecraftChannelIdentifier.from("t2c:cguiopl");
    public static final MinecraftChannelIdentifier aresp = MinecraftChannelIdentifier.from("t2c:aresp");
    public static final MinecraftChannelIdentifier opsec = MinecraftChannelIdentifier.from("t2c:opsec");


    @Inject
    public  T2CodeVMain(ProxyServer server, Logger logger) throws IOException {
        // Plugin startup logic
        T2CodeVMain.server = server;
        T2CodeVMain.logger = logger;
        pluginContainer = server.getPluginManager().getPlugin("t2codelib");

        // orgVersion = plugin.getDescription().getVersion();
       // autor = plugin.getDescription().getAuthor();

        int pluginId = Util.getBstatsID();
   //     T2CVmetrics metrics = metricsFactory.make(this, pluginId);


    }

    @Subscribe
    public void onProxyShutdown(ProxyShutdownEvent event) {
        // Plugin shutdown logic
        T2CVPlayers.sendToSpigotDeleteAll();

        T2CVsend.console(Util.getPrefix() + "§4============================= " + Util.getPrefix() + " §4=============================");
        T2CVsend.console(Util.getPrefix() + " §2Autor: §6" + String.valueOf(pluginContainer.get().getDescription().getAuthors()).replace("[", "").replace("]", ""));
        
        T2CVsend.console(Util.getPrefix() + " §2Spigot: §6" + Util.getSpigot());
        T2CVsend.console(Util.getPrefix() + " §2Discord: §6" + Util.getDiscord());
        T2CVsend.console(Util.getPrefix() + " §4Plugin successfully disabled.");
        T2CVsend.console(Util.getPrefix() + "§4============================= " + Util.getPrefix() + " §4=============================");
    }


    @Subscribe
    public void onProxyInitialize(ProxyInitializeEvent event) {
        // Schedule the task to check for updates every 60 minutes
        Scheduler scheduler = server.getScheduler();

        scheduler.buildTask(this, this:: checkForUpdates)
                .repeat(60, TimeUnit.MINUTES)
                .schedule();
    }
    private void checkForUpdates() {
        T2CVupdateAPI.checkForUpdates(pluginContainer, prefix,  Util.getDiscord(), Util.getSpigotID(), Util.getGit());
    }
}
